#! /bin/sh
#
# Medium changer test script.
#	execute each chs command and option, for all the medium changer
#	devices attaced.
#
for i in `eval "/usr/bin/ls /dev/chgr*"`
do
    echo "\n\t<< What driver/version is in use >>"
    echo "chs -f $i dri"
    chs -f $i dri

    echo "\n\t<< What is the medium changer HW configuration >>"
    echo "chs -f $i har"
    chs -f $i har

    echo "\n\t<< Initialize changer elements >>"
    echo "chs -f $i ini"
    chs -f $i ini

    echo "\n\t <<Get changer inventory >>"
    echo "chs -f $i inv"
    chs -f $i inv

    echo "\n\t<< Get changer inventory \(show media labels\) >>"
    echo "\n\t\(this will fail if the device does'nt support barcode labels\)"
    echo "chs -f $i inv -l"
    chs -f $i inv -l

    echo "\n\t<< Search for all media labels beginning with the string DAV >>"
    echo "\n\t\(this will fail if the device does'nt support barcode labels\)"
    echo "chs -f $i search -n """DAV*""" -l"
    chs -f $i search -n "DAV*" -l

    echo "\n\t<< Load media from first slot into first drive >>"
    echo "chs -f $i select -s1 -d1"
    chs -f $i select -s1 -d1

    echo "\n\t<< Eject media from drive >>"
    echo "Please enter tape device name (e.g., /dev/rmt/0)" ; read TAPEDEV
    echo "mt -f $TAPEDEV offline"
    mt -f $TAPEDEV offline

    echo "\n\t<< Return media in first drive to its previous slot >>"
    echo "chs -f $i deselect -d1"
    chs -f $i deselect -d1

    echo "\n\t<< Load media from third slot into first drive >>"
    echo "chs -f $i select -s3 -d1"
    chs -f $i select -s3 -d1

    echo "\n\t<< Move media in first slot to third slot >>"
    echo "chs -f $i mov -s1 -s3"
    chs -f $i mov -s1 -s3

    echo "\n\t<< Eject media from drive >>"
    echo "mt -f $TAPEDEV offline"
    mt -f $TAPEDEV offline

    echo "\n\t<< Unload media in the first drive to the first slot >>"
    echo "chs -f $i deselect -d1 -s1"
    chs -f $i deselect -d1 -s1

    echo "\n\t<< Import media to first drive >>"
    echo "chs -f $i import -d1"
    chs -f $i import -d1

    echo "\n\t<< Export media from first drive >>"
    echo "chs -f $i export -d1"
    chs -f $i export -d1

    echo "\n\t<< Position transport element to first drive >>"
    echo "chs -f $i pos -d1"
    chs -f $i pos -d1

    echo "\n\t<< Position transport element to slot 5 >>"
    echo "chs -f $i pos -s5"
    chs -f $i pos -s5

    echo "\n\t<< Park transport element >>"
    echo "chs -f $i pos"
    chs -f $i pos 

    echo "\n\t<< Exchange media in slot 3 with media in slot 5 >>"
    echo "\n\t (Exchange is not currently supported for most changer devices,"
    echo "\n\t  so this will proabably generate an error\)"
    echo "chs -f $i exchange -s3 -s5"
    chs -f $i exchange -s3 -s5

    echo "\n\t << Lock/Unlock changer device. >>"
    echo "\n\t (Lock/Unlock not supported for all changer devices)"
    echo "chs -f $i lock"
    chs -f $i lock
    echo "chs -f $i unlock"
    chs -f $i unlock

    echo "\n\t<< Reset changer >>"
    echo "\(will get an EPERM error if not root user\)"
    echo "chs -f $i reset"
    chs -f $i reset

    echo ^L
done

